var
    TO TS Y GDP CE PiY pE pER pEF pZ pW LH LL L pLH pLL pL pO_RoW
    W Zd Ze Ze_RoW CH CL CG IPZ IPR IPF IGZ IGRinf IGRgen IGFinf IGFgen Y_RoW 
    A BP BG BW KZ KR KF KPZ KPR KPF KGZ KGRinf KGRgen KGFinf KGFgen
    PiH PiL lamH lamL Lam QZ QR QF pSZ pSR pSF vph pZ_RoW RER dNER PiY_RoW GamE dGamER
    R RB RS RW
    T TCH TCL TA TR TH TL TSZ TSR TSF TPZ TPR TPF TEF SER SEF
    NL LZ LR LF ELe 
    DZ BZ DR BR DF BF DE uZ EZ EY ER EF SZ SF O GamW 
    VWL VR VR_RoW VpO_RoW
    VC  VNH VNL VGamB VGamS VPZ VLH VLL VZ VSZE VKZ VCG VIG VGamW VY_RoW VpZ_RoW VER VE VEF VY VW VWI VW_RoW VPiY_RoW
    Con IG IP Inv Ex Im GDP_m Inv_m E TB EF_ann ER_ann EY_ann EZ_ann O_ann
    dlnGDP dlnC dlnL dlnI dlnIG dlnIP dlnCG dlnEx dlnIm dlnpE dlnpZ dlnpEF dlnY_RoW dlnpZ_RoW dlnpO_RoW dlnEF dlnER dlnEY dlnEZ dlnO
    dlnEF_ann dlnER_ann dlnEY_ann dlnEZ_ann dlnO_ann dlnCE
    devR devRB devPiY devEL devRER devu devPiY_RoW devRW devPiH_inf devPiL_con_long
;

varexo epsWL epsR epsRW epsC epsNH epsNL epsRB epsRS epsPZ epsZ epsSZE epsKZ epsCG epsIG epsY_RoW epspZ_RoW epsGamW epsER epsE epsEF epsY epsW epsWI epsW_RoW epsLH epsLL epspO_RoW epsPiY_RoW epsDE
       epsGDP_m epsInv_m
;

parameters
    bet psiA GamB GamS  
    kap vrh
    etaH etaL
    tauW tauP tauI tauZ2 tauO tauZe tauE alpO psiu
    muP muW delZ delR delF sigSZ sigSF sigL sigW sigKZ sigKR sigKF sigZ sigE sigY sigW_RoW sigER sigEF
    tC tA tR tH tL tS tP tEF tO sER sEF
    phiWE phiWP phiEE phiCY phiIYZ phiIYRinf phiIYRgen phiIYFinf phiIYFgen phiRP phiRY phidRP phidRY xiELe
    rhoWL rhoR rhoW rhoWI rhoW_RoW rhopO_RoW
    rhoC rhoNH rhoNL rhoRB rhoGamW rhoRS rhoPZ rhoLH rhoLL rhoZ rhoSZE rhoKZ rhoCG rhoIG rhoY_RoW rhopZ_RoW rhoER rhoE rhoEF rhoY rhoPiY_RoW rhoDE
    psiC psiNH psiNL TLL lam tauZ1 gamW alpW_RoW alpL alpSZ alpW alpZ alpER alpEF alpE alpSF alpY alpKZ alpKR alpKF
    g_bar g_bar_RoW PiY_bar PiH_bar PiL_bar R_bar CG_bar IGZ_bar IGRinf_bar IGRgen_bar IGFinf_bar IGFgen_bar Y_RoW_bar pZ_RoW_bar RERBWY_bar RW_bar pO_RoW_bar PiY_RoW_bar
    GDP_bar ELe_bar BGY_bar BPY_bar uZ_bar LHLL_bar RER_bar CHCL_bar EYEZ_bar ZeRoWY_bar EREF_bar OY_bar EY_bar WYZ_bar WYE_bar LRLF_bar IPZY_bar IPRY_bar IPFY_bar
    RBbar Cbar Lbar Ibar IGbar IPbar Exbar Imbar RERbar pLbar pEbar pZbar Ebar EFbar ERbar EYbar EZbar Obar pEFbar 
;

% Household sector:	%THE CALIBRATION OF ESTIMATED PARAMETERS WILL BE OVERWRITTEN BY THE POSTERIOR MEANS
bet      = 0.99;
psiA     = 1;
GamB     = 0.001;
GamS     = 0.013;
kap      = 0.6517;
vrh      = 0.6883;
etaH     = 1.5140;

% Firm sector:
muP      = 0.2;	  
muW      = 0.2;	  
delZ     = 0.025;
delR     = 0.03;
delF     = 0.02;

%Input shares
alpO     = 0.87;

%Elasticities
sigY     = 0.1; 
sigSZ    = 0.75;
sigL     = 3.70;
sigW     = 1.80;
sigKZ    = 1.01;
sigKR    = 1.01;
sigKF    = 1.01;
sigZ     = 1.01; 
sigSF    = 0.04;
sigE     = 10;
sigW_RoW = 1.1;
sigER    = 0.3;
sigEF    = 0.3;

% Adjustment cost scaling paramters:
tauW     = 28;
tauP     = 103;
tauI     = 2.15;
tauZ2    = 0.27;
tauO     = 2.81;
tauZe    = 4.28;
tauE     = 1;

%Scaling parameters
psiu     = 3.64;

% Adjustment elasticities:
phiWE    = 0.6;
phiWP    = 0.2;
phiEE    = 0;
xiELe    = 0.95;
phiCY    = -0.16;
phiIYZ   = -0.03;
phiIYRinf= -0.03;
phiIYRgen= -0.03;
phiIYFinf= -0.03;
phiIYFgen= -0.03;
phiRP    = 1.1; 
phiRY    = 0.1;
phidRP   = 0;
phidRY   = 0;

% Taxes, transfers, and tax rates: OECD Revenue Statistics 2017: Tax/GDP is 25% https://data.oecd.org/tax/tax-revenue.htm#indicator-chart 
tC       = 0.18;     %Taxes on goods and services are 11% of GDP
tA       = 0.00027;  %Property taxes are 1% of GDP
tR       = 0.008;    %PIT is 4% of GDP
tH       = 0.08;     %PIT is 4% of GDP
tL       = 0.06;     %PIT is 4% of GDP
tS       = 0.17;     %Social Security Payroll taxes are 7% of GDP
tP       = 0.05;     %Corporate profit taxes are 2% of GDP
tEF      = 0.0233;   %Fossil fuel taxes are 1.412% of GDP https://data.oecd.org/envpolicy/environmental-tax.htm (This data says "energy taxes" but it does not include the electricity consumption tax)
tO       = 0.00001; 
sER      = 0.00001;  %Renewable energy subsidies
sEF      = 0.0067;   %IMF Perry/Black find 0.4% of GDP in explicit fuel subsidies 

% Persistence parameters of endogenous and exogenous shock processes:
rhoWL     = 0.3906;
rhoR      = 0.8;	
rhoC      = 0.4464;
rhoNH     = 0.5;	
rhoNL     = 0.5;	
rhoRB     = 0.5;	
rhoGamW   = 0.5;	
rhoRS     = 0.5;	
rhoPZ     = 0.6;
rhoLH     = 0.7825;
rhoLL     = 0.7825;
rhoZ      = 0.6124;
rhoSZE    = 0.6124;
rhoKZ     = 0.25;   
rhoCG     = 0.6256;
rhoIG     = 0.6866;
rhoY_RoW  = 0.6862;
rhopZ_RoW = 0.6466;
rhoER     = 0.5745;
rhoE      = 0.8518;
rhoEF     = 0.5575;
rhoY      = 0.8768;
rhoW      = 0.7216;	
rhoWI     = 0.8241;
rhoW_RoW  = 0;
rhopO_RoW = 0.7262;
rhoPiY_RoW= 0.5;	
rhoDE     = 0.5;

% Exogenous steady-state values (no parameter needs to be restricted to realize the steady-state value)
g_bar     = 1.0083;   %3.32% annual GDP/LF growth over 2010-2016 (FRED)
g_bar_RoW = 1.003;    %1.2%  annual per capita GDP growth in EU over 2000-2020 (Eurostat)
PiY_bar   = 1.0199;   %7.96% mean inflation rate over 2010-2016 (FRED)
PiH_bar   = g_bar*PiY_bar;
PiL_bar   = g_bar*PiY_bar;
R_bar     = 1.0219;   %8.76% short-term interest rate over 2010-2016(FRED)
RW_bar    = 1.0036;   %1.45% mean 10-year government bond rate for Germany over 2010-2016
CG_bar    = 0.14;     %World Bank
IGZ_bar   = 0.036;    %for 2017 government gross investment/GDP is 0.04 (Turkish Statistical Institute + OECD)
IGRinf_bar= 0.001;    %public energy investment is 0.004 https://www.sbb.gov.tr/yatirimlar/yatirimlarin-sektorel-dagilimi/
IGRgen_bar= 0.001;    %public energy investment is 0.004 https://www.sbb.gov.tr/yatirimlar/yatirimlarin-sektorel-dagilimi/
IGFinf_bar= 0.001;
IGFgen_bar= 0.001;
RERBWY_bar= -1.6;     %https://en.wikipedia.org/wiki/Net_international_investment_position
Y_RoW_bar = 1;
pZ_RoW_bar= 1;
PiY_RoW_bar= 1.0031;  %1.2% mean inflation rate for the Euro Zone over 2010-2016
pO_RoW_bar= 0.07;     %pO such that total carbon input into energy sector is 3% of GDP

% Endogenous steady-state values (some parameter needs to be restricted to realize the steady-state value)
GDP_bar   = 1;        %psiC
ZeRoWY_bar= 0.26;     %alpW 0.26, averaged over 2000-2019, import share %with Ybar=1 and RER=1, 1-alpY is the steady-state imports/GDP ratio. ZeRoWY is the ratio of the value of imports in domestic currency and deflated by local GDP deflator and domestic real GDP.
LHLL_bar  = 1;        %psiNH US data (No Turkish data available for wealth distribution)
BGY_bar   = 1.32;     %TLL Debt securities: 20% domestic 12% foreign for 2020 https://stats.bis.org/statx/srs/table/c3?c=TR&f=pdf The rest is loans - Page 8 - https://www.tcmb.gov.tr/wps/wcm/connect/960e0b6e-2fd0-43e9-85ef-4fdd363d425e/2017-I.Quarter.pdf?MOD=AJPERES&CACHEID=ROOTWORKSPACE-960e0b6e-2fd0-43e9-85ef-4fdd363d425e-m5lU.P0
BPY_bar   = 2.3;      %lam 
IPZY_bar  = 0.223;    %alpKZ total private investment/GDP averaged over 2002-2019 is 23%
IPRY_bar  = 0.003;    %alpKR private energy investment averaged over 2002-2019 is 0.007 of GDP (currently 0.006 because of alpKER and alpKEF)
IPFY_bar  = 0.004;    %alpKF 
WYZ_bar   = 0.39;     %alpZ  Gloria - 2014 - the ratio of labor income in core goods to core goods (value-added+energy bill)
WYE_bar   = 0.08;     %alpEF Gloria - 2014 - the ratio of labor income in energy to energy sectors' (value-added+carbon bill)
LRLF_bar  = 0.15;     %alpER - GDLD and GTAP-Power - the ratio of renewable employment to fossil employment
EY_bar    = 0.067;    %alpY GLORIA - 2014 - the share of (value-added of carbon mining+energy sector+total carbon bill of the economy) in GDP 
EYEZ_bar  = 0.94;     %alpSZ, average over 2000-2019, IEA data, the share of household energy consumption (residential+other final consumption+half of transportation) to firm energy consumption (industry+commercial/public+half of transportation) 
EREF_bar  = 0.20;     %alpE The ratio between renewable energy and fossil energy, average of last three years
CHCL_bar  = 2;        %alpL TUIK data on distribution of consumption by income quintiles
OY_bar    = 0.46;     %alpSF CO2 emission, average of 2000-2019 https://data.worldbank.org/indicator/EN.ATM.CO2E.KD.GD?locations=TR 
uZ_bar    = 1;        %tauZ1
RER_bar   = 1;        %alpW_RoW

% All of these parameters are overwritten in the steadystate file to satisfy the endogenous steady-state calibration targets above
                   
psiC     = 0;
psiNH    = 0;
psiNL    = 0;
TLL      = 0;
lam      = 0;
gamW     = 0;
alpW_RoW = 0;
alpSZ    = 0;
alpZ     = 0;
alpW     = 0;
alpS     = 0;
alpL     = 0;
alpE     = 0;
alpER    = 0;
alpEF    = 0;
alpY     = 0;
alpSF    = 0;
tauZ1    = 0;
alpKZ    = 0;
alpKR    = 0;
alpKF    = 0;

RBbar    = 0;
Cbar     = 0;
Lbar     = 0;
Ibar     = 0;
IGbar    = 0;
IPbar    = 0;
Exbar    = 0;
Imbar    = 0;
RERbar   = 0;
pLbar    = 0;
pEbar    = 0;
pZbar    = 0;
Ebar     = 0;
EFbar    = 0;
ERbar    = 0;
EYbar    = 0;
EZbar    = 0;
Obar     = 0;
pEFbar   = 0;
ELe_bar  = 0;      %psiNL unemployment rate is 10% (2006-2020) https://fred.stlouisfed.org/series/LRUN64TTTRQ156S

etaL     = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

model;

% High-skilled labor households (continuum of differentiated labor services plus perf. competitive homogenizer)
(1+tC)*lamH = VC*psiC*(CH-kap*CH(-1)/g_bar)^(-vrh);
(1+tA)*lamH - psiA = bet*(RB-tR*(RB-1))/PiY(+1)*lamH(+1)/g_bar;
(1+tA)*lamH - psiA = bet*(1-GamW)*(RW-tR*(RW-1))/PiY(+1)*dNER(+1)*lamH(+1)/g_bar;   %When S_t (Lira/Euro) increases, Lira depreciates relative to Euro. When RW increases dNER(+1) needs to fall. That is Lira must depreciate today and be expected to appreciate tomorrow. 
dNER=RER/RER(-1)*PiY/PiY_RoW;
GamW = gamW*(VGamW^(1/gamW)*exp(RER*BW/GDP)-1);
(1+tA)*lamH - psiA = bet*(1-GamS*VGamS^(1/GamS))*(RS-tR*(RS-1))/PiY(+1)*lamH(+1)/g_bar;
(1-tH)*pLH*LH =  VNH*psiNH*LH^(1+etaH)/lamH*(1+muW) - tauW*muW*((PiH-PiH_bar)*PiH - bet*lamH(+1)/lamH*(PiH(+1)-PiH_bar)*PiH(+1));
CH + A + TCH + TA + TH + TR = pLH*LH + RB(-1)/PiY*(BG(-1)+BP(-1))/g_bar + RW(-1)/PiY_RoW*RER*BW(-1)/g_bar + RS(-1)/PiY*(pSZ(-1)+pSR(-1)+pSF(-1))/g_bar + (1-alpO)*RER*pO_RoW*O + DE;
pSZ = Lam(+1)*g_bar*(pSZ(+1)+DZ(+1));
pSR = Lam(+1)*g_bar*(pSR(+1)+DR(+1));
pSF = Lam(+1)*g_bar*(pSF(+1)+DF(+1));
Lam = (RS(-1)/PiY)^(-1);

% Low-skilled labor households
(1+tC)*lamL = VC*psiC*(CL-kap*CL(-1)/g_bar)^(-vrh);
VNL*psiNL*NL^etaL = (1-tL)*lamL*pLL;
CL + TCL + TL = pLL*LL + TLL;

% Retailers (combining cars with fuel)
W = VY^(sigY-1)*alpY*pW^(-sigY)*Y;
EY = VY^(sigY-1)*(1-alpY)*pE^(-sigY)*Y;
1 = VY^(-1)*(alpY*pW^(1-sigY) + (1-alpY)*pE^(1-sigY))^(1/(1-sigY));

% Wholesalers (combining domestic and foreign unfueled cars)
Zd = VW^(sigW-1)*alpW*(pZ/pW)^(-sigW)*W;
Ze_RoW = VWI^(sigW-1)*(1-alpW)*(RER*pZ_RoW/pW)^(-sigW)*W;
pW = (alpW*VW^(sigW-1)*pZ^(1-sigW) + (1-alpW)*VWI^(sigW-1)*(RER*pZ_RoW)^(1-sigW))^(1/(1-sigW));

% Intermediate goods firms (continuum of differentiated good producers plus perf. competitive homogenizer)
vph*(1+VPZ*muP)*1/pZ - (1-tP)*tauP*VPZ*muP*((pZ/pZ(-1)*PiY-PiY_bar)*PiY/pZ(-1)-Lam(+1)*(pZ(+1)/pZ*PiY(+1)-PiY_bar)/pZ*pZ(+1)/pZ*PiY(+1)*(Zd(+1)+Ze(+1))*g_bar/(Zd+Ze)) = 1-tP;
(1-tP)*(1+tS)*pL = vph*alpSZ^(1/sigSZ)*((Zd+Ze)/SZ)^(1/sigSZ)*(1-alpZ)^(1/sigZ)*VZ^((sigZ-1)/sigZ)*(SZ/LZ)^(1/sigZ);
1 = QZ - (1-tP)*QZ*(tauI/2*(IPZ/IPZ(-1)-1)^2+tauI*(IPZ/IPZ(-1)-1)*IPZ/IPZ(-1)) + Lam(+1)*(1-tP)*QZ(+1)*tauI*(IPZ(+1)/IPZ-1)*(IPZ(+1)/IPZ)^2*g_bar;
(1-tP)*(tauZ1+tauZ2*(uZ-1))*KZ(-1)/g_bar = vph*alpSZ^(1/sigSZ)*((Zd+Ze)/SZ)^(1/sigSZ)*alpZ^(1/sigZ)*VZ^((sigZ-1)/sigZ)*(KZ(-1)/g_bar)^((sigZ-1)/sigZ)*(SZ/uZ)^(1/sigZ);
QZ = Lam(+1)*(vph(+1)*alpSZ^(1/sigSZ)*((Zd(+1)+Ze(+1))/SZ(+1))^(1/sigSZ)*alpZ^(1/sigZ)*VZ(+1)^((sigZ-1)/sigZ)*uZ(+1)^((sigZ-1)/sigZ)*(SZ(+1)/(KZ/g_bar))^(1/sigZ)*alpKZ^(1/sigKZ)*VKZ^((sigKZ-1)/sigKZ)*(KZ/KPZ)^(1/sigKZ) + (1-(1-tP)*delZ)*QZ(+1)) + lam*(1-delZ)*PiY(+1)*(1/RB-1/RS);
(1-tP)*pE = vph*(1-alpSZ)^(1/sigSZ)*VSZE^((sigSZ-1)/sigSZ)*((Zd+Ze)/EZ)^(1/sigSZ);
KPZ = (1-tauI/2*(IPZ/IPZ(-1)-1)^2)*IPZ + (1-delZ)*KPZ(-1)/g_bar;
Zd+Ze = (alpSZ^(1/sigSZ)*SZ^((sigSZ-1)/sigSZ)+(1-alpSZ)^(1/sigSZ)*(VSZE*EZ)^((sigSZ-1)/sigSZ))^(sigSZ/(sigSZ-1));
SZ = VZ*(alpZ^(1/sigZ)*(uZ*KZ(-1)/g_bar)^((sigZ-1)/sigZ)+(1-alpZ)^(1/sigZ)*LZ^((sigZ-1)/sigZ))^(sigZ/(sigZ-1));
KZ = VKZ*(alpKZ^(1/sigKZ)*KPZ^((sigKZ-1)/sigKZ)+(1-alpKZ)^(1/sigKZ)*KGZ^((sigKZ-1)/sigKZ))^(sigKZ/(sigKZ-1));
DZ = pZ*(Zd+Ze) - pL*LZ - pE*EZ - TPZ - TSZ - IPZ + BZ - RB(-1)/PiY*BZ(-1)/g_bar;
BZ = lam*QZ(+1)*(1-delZ)*KPZ*(RB/PiY(+1))^(-1);

% Labor firm (combining homogenized high and low skilled labor)
LH = VLH^(sigL-1)*alpL*(pLH/pL)^(-sigL)*(LZ+LR+LF);
LL = VLL^(sigL-1)*(1-alpL)*(pLL/pL)^(-sigL)*(LZ+LR+LF);
pL = (alpL*VLH^(sigL-1)*pLH^(1-sigL) + (1-alpL)*VLL^(sigL-1)*pLL^(1-sigL))^(1/(1-sigL));
pLH/pLH(-1)*g_bar = PiH/PiY;
pLL/pLL(-1)*g_bar = PiL/PiY;

% Energy firms (combining renewable energy and fossil energy)
((pER-sER)/pE)^sigE = VE^(sigE-1)*(EY+EZ)*alpE*1/(GamE*ER)*(dGamER*ER+GamE)^sigE;
GamE = 1-tauE/2*(ER/ER(-1)-1)^2;
dGamER =  -tauE*(ER/ER(-1)-1)*1/ER(-1);
EF = VE^(sigE-1)*(1-alpE)*((pEF+tEF-sEF)/pE)^(-sigE)*(EY+EZ);
pE*(EY+EZ) = (pER-sER)*ER + (pEF+tEF-sEF)*EF + DE;
DE = rhoDE*DE(-1) + epsDE;

% Renewable energy firms
(1+tS)*pL = pER*(1-alpER)^(1/sigER)*VER^((sigER-1)/sigER)*(ER/LR)^(1/sigER);
1 = QR - (1-tP)*QR*(tauI/2*(IPR/IPR(-1)-1)^2+tauI*(IPR/IPR(-1)-1)*IPR/IPR(-1)) + Lam(+1)*(1-tP)*QR(+1)*tauI*(IPR(+1)/IPR-1)*(IPR(+1)/IPR)^2*g_bar;
QR = Lam(+1)*((1-tP)*pER(+1)*alpER^(1/sigER)*VER(+1)^((sigER-1)/sigER)*(ER(+1)/(KR/g_bar))^(1/sigER)*alpKR^(1/sigKR)*(KR/(KPR+KGRgen))^(1/sigKR) + (1-(1-tP)*delR)*QR(+1)) + lam*(1-delR)*PiY(+1)*(1/RB-1/RS);
KPR = (1-tauI/2*(IPR/IPR(-1)-1)^2)*IPR + (1-delR)*KPR(-1)/g_bar;
ER = VER*(alpER^(1/sigER)*(KR(-1)/g_bar)^((sigER-1)/sigER)+(1-alpER)^(1/sigER)*LR^((sigER-1)/sigER))^(sigER/(sigER-1));
KR = (alpKR^(1/sigKR)*(KPR+KGRgen)^((sigKR-1)/sigKR)+(1-alpKR)^(1/sigKR)*KGRinf^((sigKR-1)/sigKR))^(sigKR/(sigKR-1));
DR = pER*ER - pL*LR - TPR - TSR - IPR + BR - RB(-1)/PiY*BR(-1)/g_bar;
BR = lam*QR(+1)*(1-delR)*KPR*(RB/PiY(+1))^(-1);

% Fossil energy firms
(1+tS)*pL = pEF*alpSF^(1/sigSF)*(EF/SF)^(1/sigSF)*(1-alpEF)^(1/sigEF)*VEF^((sigEF-1)/sigEF)*(SF/LF)^(1/sigEF);
1 = QF - (1-tP)*QF*(tauI/2*(IPF/IPF(-1)-1)^2+tauI*(IPF/IPF(-1)-1)*IPF/IPF(-1)) + Lam(+1)*(1-tP)*QF(+1)*tauI*(IPF(+1)/IPF-1)*(IPF(+1)/IPF)^2*g_bar;
QF = Lam(+1)*((1-tP)*pEF(+1)*alpSF^(1/sigSF)*(EF(+1)/SF(+1))^(1/sigSF)*alpEF^(1/sigEF)*VEF(+1)^((sigEF-1)/sigEF)*((SF(+1))/(KF/g_bar))^(1/sigEF)*alpKF^(1/sigKF)*(KF/(KPF+KGFgen))^(1/sigKF) + (1-(1-tP)*delF)*QF(+1)) + lam*(1-delF)*PiY(+1)*(1/RB-1/RS);
tO + RER*pO_RoW + tauO*(O/O(-1)-1)*1/g_bar - Lam(+1)*tauO*(O(+1)/O-1)*O(+1)/O = pEF*(1-alpSF)^(1/sigSF)*(EF/O)^(1/sigSF);
KPF = (1-tauI/2*(IPF/IPF(-1)-1)^2)*IPF + (1-delF)*KPF(-1)/g_bar;
EF = (alpSF^(1/sigSF)*SF^((sigSF-1)/sigSF)+(1-alpSF)^(1/sigSF)*O^((sigSF-1)/sigSF))^(sigSF/(sigSF-1));
SF = VEF*(alpEF^(1/sigEF)*(KF(-1)/g_bar)^((sigEF-1)/sigEF)+(1-alpEF)^(1/sigEF)*LF^((sigEF-1)/sigEF))^(sigEF/(sigEF-1));
KF = (alpKF^(1/sigKF)*(KPF+KGFgen)^((sigKF-1)/sigKF)+(1-alpKF)^(1/sigKF)*KGFinf^((sigKF-1)/sigKF))^(sigKF/(sigKF-1));
DF = pEF*EF - pL*LF - RER*pO_RoW*O - TPF - TSF - TO - IPF + BF - RB(-1)/PiY*BF(-1)/g_bar;
BF = lam*QF(+1)*(1-delF)*KPF*(RB/PiY(+1))^(-1);

% Policy
PiL/PiL_bar = (PiL(-1)/PiL_bar)^rhoWL*(ELe/ELe_bar)^(phiWE*(1-rhoWL))*(PiY(-1)/PiY_bar)^(phiWP*(1-rhoWL))*VWL;
ELe/ELe_bar = (ELe(+1)/ELe_bar)^(bet/(1+bet))*(ELe(-1)/ELe_bar)^(1/(1+bet))*((LL/NL)/(ELe))^((1-bet*xiELe)*(1-xiELe)/((1+bet)*xiELe));
T = TCH + TCL + TA + TR + TH + TL + TSZ + TSR + TSF + TPZ + TPR + TPF + TEF + TO;
TCH = tC*CH;
TCL = tC*CL;
TA = tA*A;
TR = tR*((RB(-1)-1)/PiY*(BG(-1)+BP(-1))/g_bar + (RW(-1)-1)/PiY_RoW*RER*BW(-1)/g_bar + (RS(-1)-1)/PiY*(pSZ(-1)+pSR(-1)+pSF(-1))/g_bar);
TH = tH*pLH*LH;
TL = tL*pLL*LL;
TS = TSZ+TSR+TSF;
TSZ = tS*pL*LZ;
TSR = tS*pL*LR;
TSF = tS*pL*LF;
TPZ = tP*(pZ*(Zd+Ze) - pL*LZ - tS*pL*LZ - QZ*delZ*KPZ(-1)/g_bar - tauI/2*(IPZ/IPZ(-1)-1)^2*IPZ);
TPR = tP*(pER*ER - pL*LR - tS*pL*LR - delR*KPR(-1)/g_bar - tauI/2*(IPR/IPR(-1)-1)^2*IPR);
TPF = tP*(pEF*EF - pL*LF - tS*pL*LF - TO - RER*pO_RoW*O - delF*KPF(-1)/g_bar - tauI/2*(IPF/IPF(-1)-1)^2*IPF);
TEF = tEF*EF;
SER = sER*ER;
SEF = sEF*EF;
TO = tO*O;
CG/CG_bar = (GDP/GDP_bar)^(-phiCY)*VCG;
IGZ/IGZ_bar = (GDP/GDP_bar)^(-phiIYZ)*VIG;
IGRinf/IGRinf_bar = (GDP/GDP_bar)^(-phiIYRinf)*VIG;
IGRgen/IGRgen_bar = (GDP/GDP_bar)^(-phiIYRgen)*VIG;
IGFinf/IGFinf_bar = (GDP/GDP_bar)^(-phiIYFinf)*VIG;
IGFgen/IGFgen_bar = (GDP/GDP_bar)^(-phiIYFgen)*VIG;
KGZ = (1-tauI/2*(IGZ/IGZ(-1)-1)^2)*IGZ + (1-delZ)*KGZ(-1)/g_bar;
KGRinf = (1-tauI/2*(IGRinf/IGRinf(-1)-1)^2)*IGRinf + (1-delR)*KGRinf(-1)/g_bar;
KGRgen = (1-tauI/2*(IGRgen/IGRgen(-1)-1)^2)*IGRgen + (1-delR)*KGRgen(-1)/g_bar;
KGFinf = (1-tauI/2*(IGFinf/IGFinf(-1)-1)^2)*IGFinf + (1-delF)*KGFinf(-1)/g_bar;
KGFgen = (1-tauI/2*(IGFgen/IGFgen(-1)-1)^2)*IGFgen + (1-delF)*KGFgen(-1)/g_bar;
CG + IGZ + IGRinf + IGRgen + IGFinf + IGFgen + SER + SEF + TLL + RB(-1)/PiY*BG(-1)/g_bar = T + BG;
R/R_bar = (R(-1)/R_bar)^rhoR*(pZ/pZ(-1)*PiY/PiY_bar)^(phiRP*(1-rhoR))*(GDP/GDP_bar)^(phiRY*(1-rhoR))*VR;
R = (1-GamB*VGamB^(1/GamB))*RB;

% Rest of the world
pZ/RER*Ze - (pZ_RoW*Ze_RoW + alpO*pO_RoW*O) = BW - RW(-1)/PiY_RoW*BW(-1)/g_bar; 
Y_RoW = Y_RoW(-1)^rhoY_RoW*Y_RoW_bar^(1-rhoY_RoW)*VY_RoW;
Ze = VW_RoW*(1-alpW_RoW)*(((pZ+tauZe*(Ze/Ze(-1)-1)*1/g_bar_RoW)/RER)/pZ_RoW)^(-sigW_RoW)*Y_RoW;
pZ_RoW = pZ_RoW(-1)^rhopZ_RoW*pZ_RoW_bar^(1-rhopZ_RoW)*VpZ_RoW;
RW/RW_bar = VR_RoW;
PiY_RoW = PiY_RoW(-1)^rhoPiY_RoW*PiY_RoW_bar^(1-rhoPiY_RoW)*VPiY_RoW;
pO_RoW = pO_RoW(-1)^rhopO_RoW*pO_RoW_bar^(1-rhopO_RoW)*VpO_RoW;

% Market clearing
Y = CH + CL + CG + IPZ + IPR + IPF + IGZ + IGRinf + IGRgen + IGFinf + IGFgen;
BP = BZ+BR+BF;

% Indicator variables
GDP = Y+pZ*Ze-RER*(pZ_RoW*Ze_RoW + alpO*pO_RoW*O);

% Exogenous processes
VC      = VC(-1)      ^rhoC     *exp(epsC);
VNH     = VNH(-1)     ^rhoNH    *exp(epsNH);
VNL     = VNL(-1)     ^rhoNL    *exp(epsNL);
VGamB   = VGamB(-1)   ^rhoRB    *exp(epsRB);
VGamW   = VGamW(-1)   ^rhoGamW  *exp(epsGamW);
VGamS   = VGamS(-1)   ^rhoRS    *exp(epsRS);
VWL     =                        exp(epsWL);
VLH     = VLH(-1)     ^rhoLH    *exp(epsLH)    *1^(1-rhoLH);
VLL     = VLL(-1)     ^rhoLL    *exp(epsLL)    *1^(1-rhoLL);
VY      = VY(-1)      ^rhoY     *exp(epsY)     *1^(1-rhoY);
VW      = VW(-1)      ^rhoW     *exp(epsW)     *1^(1-rhoW);
VWI     = VWI(-1)     ^rhoWI    *exp(epsWI)    *1^(1-rhoWI);
VW_RoW  = VW_RoW(-1)  ^rhoW_RoW *exp(epsW_RoW) *1^(1-rhoW_RoW);
VZ      = VZ(-1)      ^rhoZ     *exp(epsZ)     *1^(1-rhoZ);
VSZE    = VSZE(-1)    ^rhoSZE   *exp(epsSZE)  *1^(1-rhoSZE);
VE      = VE(-1)      ^rhoE     *exp(epsE);
VER     = VER(-1)     ^rhoER    *exp(epsER);
VEF     = VEF(-1)     ^rhoEF    *exp(epsEF)    *1^(1-rhoEF);
VPZ     = VPZ(-1)     ^rhoPZ    *exp(epsPZ);
VKZ     = VKZ(-1)     ^rhoKZ    *exp(epsKZ);
VCG     = VCG(-1)     ^rhoCG    *exp(epsCG);
VIG     = VIG(-1)     ^rhoIG    *exp(epsIG);
VR      =                        exp(epsR);
VR_RoW  =                        exp(epsRW);
VpZ_RoW =                        exp(epspZ_RoW);
VY_RoW  =                        exp(epsY_RoW);
VPiY_RoW=                        exp(epsPiY_RoW);
VpO_RoW =                        exp(epspO_RoW);

CE=pL*(LZ+LR+LF);
L=LH+LL;
Con=CH+CL;
IG=IGRinf+IGRgen+IGFinf+IGFgen+IGZ;
IP=IPR+IPF+IPZ;
Inv=IG+IP;
Ex=pZ*Ze;
Im=RER*(pZ_RoW*Ze_RoW + alpO*pO_RoW*O);
TB=(pZ*Ze-RER*(pZ_RoW*Ze_RoW + alpO*pO_RoW*O)); 
E=EY+EZ;
EF_ann = EF+EF(-1)+EF(-2)+EF(-3);
ER_ann = ER+ER(-1)+ER(-2)+ER(-3);
EY_ann = EY+EY(-1)+EY(-2)+EY(-3);
EZ_ann = EZ+EZ(-1)+EZ(-2)+EZ(-3);
O_ann  = O+O(-1)+O(-2)+O(-3);


% Measurement error

GDP_m=GDP*exp(epsGDP_m);
Inv_m=Inv*exp(epsInv_m);

% Observed variables

dlnGDP=(GDP_m/GDP_m(-1)-1)*100;
dlnC=(Con/Con(-1)-1)*100;
dlnL=(L/L(-1)-1)*100;
dlnI=(Inv_m/Inv_m(-1)-1)*100;
dlnIG=(IG/IG(-1)-1)*100;
dlnIP=(IP/IP(-1)-1)*100;
dlnCG=(CG/CG(-1)-1)*100;
dlnEx=(Ex/Ex(-1)-1)*100;
dlnIm=(Im/Im(-1)-1)*100;
dlnCE=(CE/CE(-1)-1)*100;
dlnpE=(pE/pE(-1)-1)*100;
dlnpZ=(pZ/pZ(-1)-1)*100;
dlnpEF=((pEF+tEF)/(pEF(-1)+tEF)-1)*100;
dlnY_RoW=(Y_RoW/Y_RoW(-1)-1)*100;
dlnpZ_RoW=(pZ_RoW/pZ_RoW(-1)-1)*100;
dlnpO_RoW=(pO_RoW/pO_RoW(-1)-1)*100;
dlnEF=(EF/EF(-1)-1)*100;
dlnER=(ER/ER(-1)-1)*100;
dlnEY=(EY/EY(-1)-1)*100;
dlnEZ=(EZ/EZ(-1)-1)*100;
dlnO=(O/O(-1)-1)*100;

dlnEF_ann=dlnEF+dlnEF(-1)+dlnEF(-2)+dlnEF(-3);
dlnER_ann=dlnER+dlnER(-1)+dlnER(-2)+dlnER(-3);
dlnEY_ann=dlnEY+dlnEY(-1)+dlnEY(-2)+dlnEY(-3);
dlnEZ_ann=dlnEZ+dlnEZ(-1)+dlnEZ(-2)+dlnEZ(-3);
dlnO_ann=dlnO+dlnO(-1)+dlnO(-2)+dlnO(-3);

devR=(R-R_bar)*100;
devRB=(RB-RBbar)*100;
devPiY=(PiY-PiY_bar)*100;
devEL=(ELe-ELe_bar)*100;
devRER=(RER-RERbar)*100;
devu=psiu*(uZ-uZ_bar)*100;
devPiY_RoW=(PiY_RoW-PiY_RoW_bar)*100;
devRW=(RW-RW_bar)*100;
devPiH_inf=(PiH-PiH_bar)*100;
devPiL_con_long=(PiL-PiL_bar)*100;




end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

steady;
check;

% ESTIMATION
  
varobs dlnGDP dlnC dlnI dlnIG dlnIP dlnCG devR devRB devPiY dlnEx dlnIm devEL dlnpZ dlnpEF dlnpE devRER dlnEF_ann dlnER_ann dlnEY_ann dlnEZ_ann dlnO_ann dlnpZ_RoW dlnpO_RoW dlnY_RoW devu devPiY_RoW devRW dlnL dlnCE devPiH_inf devPiL_con_long;

estimated_params;

kap,0.6243,,,               beta_pdf,0.7,    0.05;
vrh,0.8655,,,               gamma_pdf,1.5,   0.375;
etaH,1.6131,,,              gamma_pdf,2,     0.25;
sigSZ,0.7324,,,             gamma_pdf,0.5,   0.1;
sigL,3.2579,,,              gamma_pdf,1.5,   0.5;
sigY,0.1260,,,              gamma_pdf,0.3,   0.1;
sigSF,0.0478,,,             gamma_pdf,0.3,   0.1;
sigER,0.2948,,,             gamma_pdf,0.3,   0.05;
sigEF,0.2466,,,             gamma_pdf,0.3,   0.05;
sigW,1.5671,,,              gamma_pdf,2,     0.4;
sigW_RoW,1.1977,,,          gamma_pdf,2,     0.4;
sigE,16,,,                  gamma_pdf,6,     4;
tauW,84.3649,,,             gamma_pdf,50,    20;
tauP,53.7964,,,             gamma_pdf,50,    20;
tauI,3.8259,,,              gamma_pdf,10,    4;
tauZ2,0.3024,,,             gamma_pdf,0.5,   0.1;
tauO,3.0955,,,              gamma_pdf,5,     1;
tauZe,4.1261,,,             gamma_pdf,5,     1;
tauE,0.80,,,                gamma_pdf,2,     1.25;
psiu,2.3775,,,              normal_pdf,2,     1;
xiELe,0.9692,,,             beta_pdf,0.5,   0.15;
phiWE,1.40,,,               normal_pdf,1,    0.5;
phiWP,1.00,,,               normal_pdf,1,    0.5;
phiCY,-0.1272,,,            normal_pdf,0,     0.1;
phiRP,1.15,,,               normal_pdf,1.1,   0.2;
phiRY,0,,,                  normal_pdf,0.5,   0.2;
rhoW,0.79,,,                beta_pdf,0.5,   0.1;
rhoWI,0.70,,,               beta_pdf,0.5,   0.1;
rhoW_RoW,0.30,,,            beta_pdf,0.5,   0.1;
rhoR,0.90,,,                beta_pdf,0.8,   0.1;
rhoC,0.29,,,                beta_pdf,0.5,   0.1;
rhoNH,0.51,,,               beta_pdf,0.5,   0.1;
rhoNL,0.45,,,               beta_pdf,0.5,   0.1;
rhoRB,0.55,,,               beta_pdf,0.5,   0.1;
rhoGamW,0.59,,,             beta_pdf,0.5,   0.1;
rhoRS,0.49,,,               beta_pdf,0.5,   0.1;
rhoPZ,0.69,,,               beta_pdf,0.5,   0.1;
rhoZ,0.71,,,                beta_pdf,0.5,   0.1;
rhoSZE,0.78,,,              beta_pdf,0.5,   0.1;
rhoEF,0.64,,,               beta_pdf,0.5,   0.1;
rhoER,0.83,,,               beta_pdf,0.5,   0.1;
rhoE,0.75,,,                beta_pdf,0.5,   0.1;
rhoKZ,0.65,,,               beta_pdf,0.5,   0.1;
rhoCG,0.66,,,               beta_pdf,0.5,   0.1;
rhoIG,0.70,,,               beta_pdf,0.5,   0.1;
rhoY_RoW,0.78,,,            beta_pdf,0.75,   0.05;
rhopZ_RoW,0.90,,,           beta_pdf,0.75,   0.05;
rhoWL,0.25,,,               beta_pdf,0.5,   0.1;
rhoDE,0.79,,,               beta_pdf,0.5,   0.1;
rhoLH,0.54,,,               beta_pdf,0.5,   0.1;
rhoLL,0.69,,,               beta_pdf,0.5,   0.1;
rhoY,0.78,,,                beta_pdf,0.5,   0.1;
rhopO_RoW,0.85,,,           beta_pdf,0.75,   0.05;
rhoPiY_RoW,0.32,,,          beta_pdf,0.5,   0.1;
stderr epsWL,0.04,,,        inv_gamma_pdf,0.1,   1;
stderr epsR,0.004,,,        inv_gamma_pdf,0.01,  0.01;
stderr epsRW,0.001,,,       inv_gamma_pdf,0.001, 0.001;
stderr epsC,0.22,,,         inv_gamma_pdf,0.1,   1;
stderr epsNH,3.8633,,,      inv_gamma_pdf,0.1,   1;
stderr epsNL,4.5369,,,      inv_gamma_pdf,0.1,   1;
stderr epsRB,0.02,,,        inv_gamma_pdf,0.01,  0.01;
stderr epsRS,0.14,,,        inv_gamma_pdf,0.1,   1;
stderr epsPZ,0.87,,,        inv_gamma_pdf,0.1,   1;
stderr epsSZE,0.24,,,       inv_gamma_pdf,0.1,   1;
stderr epsZ,0.04,,,         inv_gamma_pdf,0.1,   1;
stderr epsER,0.07,,,        inv_gamma_pdf,0.1,   1;
stderr epsE,0.08,,,         inv_gamma_pdf,0.1,   1;
stderr epsEF,0.30,,,        inv_gamma_pdf,0.1,   1;
stderr epsDE,0.005,,,       inv_gamma_pdf,0.01,   1;
stderr epsLH,0.04,,,        inv_gamma_pdf,0.1,   1;
stderr epsLL,0.27,,,        inv_gamma_pdf,0.1,   1;
stderr epsKZ,0.08,,,        inv_gamma_pdf,0.1,   1;
stderr epsCG,0.04,,,        inv_gamma_pdf,0.1,   1;
stderr epsIG,0.1,,,         inv_gamma_pdf,0.1,   1;
stderr epsY_RoW,0.0174,,,   inv_gamma_pdf,0.01,  0.01;
stderr epspZ_RoW,0.01,,,    inv_gamma_pdf,0.01,  0.01;
stderr epsGamW,0.16,,,      inv_gamma_pdf,0.1,   1;
stderr epsY,0.04,,,         inv_gamma_pdf,0.1,   1;
stderr epsW,0.05,,,         inv_gamma_pdf,0.1,   1;
stderr epsWI,0.1236,,,      inv_gamma_pdf,0.1,   1;
stderr epsW_RoW,0.41,,,     inv_gamma_pdf,0.1,   1;
stderr epspO_RoW,0.0921,,,  inv_gamma_pdf,0.1,   1;
stderr epsPiY_RoW,0.0031,,, inv_gamma_pdf,0.01,  0.01;
stderr epsGDP_m,0.0353,,,   inv_gamma_pdf,0.01,  0.01;
stderr epsInv_m,0.087,,,    inv_gamma_pdf,0.01,  0.01;

end;

%dynare_sensitivity(datafile=data,rmse=1,pfilt_rmse=0.01,alpha_rmse=0.0001,pprior=0,mode_file=estimation_mode,stab=0,alpha2_rmse=1e-100,nodisplay);

%dynare_sensitivity(datafile=data,rmse=1);

set_dynare_seed('default')
estimation(datafile=data,mode_compute = 5,optim=('SaveFiles', 0),mh_replic=50000,mode_check,mh_jscale=0.225);




