



load cond_forecast_policy.mat
load estimation_results.mat
steady;

len=M_.endo_nbr-20;    %20 auxiliary variables
lex=M_.exo_nbr;
equalsign_sim=cell(len+lex,1);
for i = 1:len+lex
  equalsign_sim{i} = "=";
end
semicolon_sim=cell(len+lex,1);
for i = 1:(len+lex)
  semicolon_sim{i} = ";";
end
cell2csv("initval_sim.mod",[[M_.endo_names(1:len);M_.exo_names] equalsign_sim mat2cell([oo_.steady_state(1:len);zeros(M_.exo_nbr,1)],ones(len+lex,1),1) semicolon_sim]," ");	%generates the initial values for the first period perfect foresight simulation.

shocks_all_IGRinfd  = [log(cumprod(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="VIGRinfd")),1:121)))]';
shocks_all_IGFgend  = [log(cumprod(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="VIGFgend")),1:121)))]';
shocks_all_IGFinfd  = [log(cumprod(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="VIGFinfd")),1:121)))]';
shocks_all_epsIGFbb = [cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="IGFbb")),1:121)]';
shocks_all_tOd      = [cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="tOd")),1:121)]'-M_.params(find(M_.param_names=="tO"));
shocks_all_sEFd     = [cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="sEFd")),1:121)]'-M_.params(find(M_.param_names=="sEF"));
shocks_all_sERd     = [cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="sERd")),1:121)]'-M_.params(find(M_.param_names=="sER"));
shocks_all_CGd      = [cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="CGd")),1:121)]';
shocks_all_TLLd     = [cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="TLLd")),1:121)]'-M_.params(find(M_.param_names=="TLL"));


if scenario == "surprise_simulation" | scenario == "reversal_simulation"

for per = 1:121
    
    tmp = ['Period ',num2str(per)]; disp(tmp);
    dynare estimation noclearall;
    simul_surprise(:,per) = oo_.endo_simul(:,2);
    simul_reversal(:,per) = oo_.endo_simul(:,2);
    
    cell2csv("initval_sim.mod",[[M_.endo_names(1:len);M_.exo_names] equalsign_sim mat2cell([oo_.endo_simul(1:len,2);oo_.exo_simul(2,:)'],ones(len+lex,1),1) semicolon_sim]," "); %updates the initial values for the second, third, ... perfect foresight simulation. 

end

if scenario == "surprise_simulation"
   save('simul_surprise.mat','simul_surprise')
end

if scenario == "reversal_simulation"
   save('simul_reversal.mat','simul_reversal')
end
end


if scenario == "perfect_foresight_simulation"

shocks_all_IGRinfd  = [shocks_all_IGRinfd;  shocks_all_IGRinfd(end)*ones(200,1)];
shocks_all_IGFgend  = [shocks_all_IGFgend;  shocks_all_IGFgend(end)*ones(200,1)];
shocks_all_IGFinfd  = [shocks_all_IGFinfd;  shocks_all_IGFinfd(end)*ones(200,1)];
shocks_all_epsIGFbb = [shocks_all_epsIGFbb; shocks_all_epsIGFbb(end)*ones(200,1)];
shocks_all_tOd      = [shocks_all_tOd;      shocks_all_tOd(end)*ones(200,1)]*0.8;
shocks_all_sEFd     = [shocks_all_sEFd;     shocks_all_sEFd(end)*ones(200,1)];
shocks_all_sERd     = [shocks_all_sERd;     shocks_all_sERd(end)*ones(200,1)];
shocks_all_CGd      = [shocks_all_CGd;      shocks_all_CGd(end)*ones(200,1)];
shocks_all_TLLd     = [shocks_all_TLLd;     shocks_all_TLLd(end)*ones(200,1)];

dynare estimation noclearall;

simul_perfect_foresight = oo_.endo_simul(:,2:122);
save('simul_perfect_foresight.mat','simul_perfect_foresight')

end
