
load simulation_results_tO.mat
oo1=oo_;
load simulation_results_sER.mat
oo2=oo_;
load simulation_results_IGRgen.mat
oo3=oo_;
load simulation_results_IGRinffree.mat
oo4=oo_;
load simulation_results_IGRinf.mat
oo5=oo_;

H=40;
qtr=(1:H);
color=[[0 0.4470 0.7410];[0.8500 0.3250 0.0980];[0.9290 0.6940 0.1250];[0.4940 0.1840 0.5560];[0.4660 0.6740 0.1880];[0.3010 0.7450 0.9330];[0.6350 0.0780 0.1840]];
linestyle=["-","--","-.",":",":"];
markerstyle=["none","none","none","o","+"];
instruments=["Carbon tax", "Renewable energy subsidy", "Public investment in RE generation", "Pub. inv. in RE infrastructure (below saturation)", "Pub. inv. in RE infrastructure (above saturation)"];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





sim=[];
scaling=[282750,282750000000/1000/1000,3.8687*282750000000/1000000/1000*23.88458966275];  
y=["PGD","O","ER"];
titles=["Public primary deficit","Carbon emissions","Renewable energy production"];
ynames=["Billions of 2015 USD","Millions of tonnes of CO2 emissions","Millions of tonnes of oil equivalent"];

for iter = 1:length(instruments)
  for ii   = 1:length(y)
    sim(:,iter,ii) = eval(strcat('oo',num2str(iter),'.endo_simul(find(M_.endo_names=="',y(ii),'"),2:41)-oo',num2str(iter),'.steady_state(find(M_.endo_names=="',y(ii),'"))'))*scaling(ii);
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h=[];
tmp=figure('visible','off');
tlo=tiledlayout(1,length(y));
for ii=1:length(y)
  nexttile(tlo)
  hold on
  
  plot(qtr,zeros(1,length(qtr)),'LineStyle',':','LineWidth',0.5,'Color','k');
  
  for iter = 1:length(instruments)
    h(iter)=plot(qtr,sim(:,iter,ii),'LineStyle',linestyle(iter),'Marker',markerstyle(iter),'MarkerIndices',5:5:H,'LineWidth',1,'color',color(iter,:));
  end

  grid on
  xlim([0;H]);
  title(titles(ii));
  ylabel(ynames(ii));
  xlabel("Quarters after policy shock");
end
leg=legend(h,instruments,'Orientation','horizontal','Box','off');
leg.Layout.Tile = 'South';
set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 16 4]);
print(tmp,'-depsc','Figure_3a.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






sim=[];
scaling=[3.8687*282750000000/1000000/1000*23.88458966275,282750,282750];  
y=["EF","GDP","IPR"];
titles=["Fossil energy production","Gross domestic product","Private investment in renewable energy"];
ynames=["Millions of tonnes of oil equivalent","Billions of 2015 USD","Billions of 2015 USD"];

for iter = 1:length(instruments)
  for ii   = 1:length(y)
    sim(:,iter,ii) = eval(strcat('oo',num2str(iter),'.endo_simul(find(M_.endo_names=="',y(ii),'"),2:41)-oo',num2str(iter),'.steady_state(find(M_.endo_names=="',y(ii),'"))'))*scaling(ii);
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h=[];
tmp=figure('visible','off');
tlo=tiledlayout(1,length(y));
for ii=1:length(y)
  nexttile(tlo)
  hold on
  
  plot(qtr,zeros(1,length(qtr)),'LineStyle',':','LineWidth',0.5,'Color','k');
  
  for iter = 1:length(instruments)
    h(iter)=plot(qtr,sim(:,iter,ii),'LineStyle',linestyle(iter),'Marker',markerstyle(iter),'MarkerIndices',5:5:H,'LineWidth',1,'color',color(iter,:));
  end

  grid on
  xlim([0;H]);
  title(titles(ii));
  ylabel(ynames(ii));
  xlabel("Quarters after policy shock");
end
leg=legend(h,instruments,'Orientation','horizontal','Box','off');
leg.Layout.Tile = 'South';
set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 16 4]);
print(tmp,'-depsc','Figure_3b.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



sim=[];
scaling=[282750,282750,282750];
y=["IPF","Ex","Im_nooil"];
titles=["Private investment in fossil energy","Exports","Non-oil imports"];
ynames=["Billions of 2015 USD","Billions of 2015 USD","Billions of 2015 USD"];

for iter = 1:length(instruments)
  for ii   = 1:length(y)
    sim(:,iter,ii) = eval(strcat('oo',num2str(iter),'.endo_simul(find(M_.endo_names=="',y(ii),'"),2:41)-oo',num2str(iter),'.steady_state(find(M_.endo_names=="',y(ii),'"))'))*scaling(ii);
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h=[];
tmp=figure('visible','off');
tlo=tiledlayout(1,length(y));
for ii=1:length(y)
  nexttile(tlo)
  hold on
  
  plot(qtr,zeros(1,length(qtr)),'LineStyle',':','LineWidth',0.5,'Color','k');
  
  for iter = 1:length(instruments)
    h(iter)=plot(qtr,sim(:,iter,ii),'LineStyle',linestyle(iter),'Marker',markerstyle(iter),'MarkerIndices',5:5:H,'LineWidth',1,'color',color(iter,:));
  end

  grid on
  xlim([0;H]);
  title(titles(ii));
  ylabel(ynames(ii));
  xlabel("Quarters after policy shock");
end
leg=legend(h,instruments,'Orientation','horizontal','Box','off');
leg.Layout.Tile = 'South';
set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 16 4]);
print(tmp,'-depsc','Figure_3c.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



sim=[];
scaling=[282750,400000,400000];
y=["Im_oil","PiY","PiE"];
titles=["Oil imports","Headline inflation","Energy price inflation"];
ynames=["Billions of 2015 USD","Percentage points","Percentage points"];

for iter = 1:length(instruments)
  for ii   = 1:length(y)
    sim(:,iter,ii) = eval(strcat('oo',num2str(iter),'.endo_simul(find(M_.endo_names=="',y(ii),'"),2:41)-oo',num2str(iter),'.steady_state(find(M_.endo_names=="',y(ii),'"))'))*scaling(ii);
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h=[];
tmp=figure('visible','off');
tlo=tiledlayout(1,length(y));
for ii=1:length(y)
  nexttile(tlo)
  hold on
  
  plot(qtr,zeros(1,length(qtr)),'LineStyle',':','LineWidth',0.5,'Color','k');
  
  for iter = 1:length(instruments)
    h(iter)=plot(qtr,sim(:,iter,ii),'LineStyle',linestyle(iter),'Marker',markerstyle(iter),'MarkerIndices',5:5:H,'LineWidth',1,'color',color(iter,:));
  end

  grid on
  xlim([0;H]);
  title(titles(ii));
  ylabel(ynames(ii));
  xlabel("Quarters after policy shock");
end
leg=legend(h,instruments,'Orientation','horizontal','Box','off');
leg.Layout.Tile = 'South';
set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 16 4]);
print(tmp,'-depsc','Figure_3d.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%








clear;
load estimation_results.mat

load cond_forecast_policy.mat
load cond_forecast_nopolicy.mat
load cond_forecast_fiscon.mat
load ci_up_nopolicy.mat
load ci_low_nopolicy.mat
load ci_up.mat
load ci_low.mat
load ci_up_dev.mat
load ci_low_dev.mat

warning('OFF', 'MATLAB:table:ModifiedAndSavedVarnames');
data = readtable('raw_data.csv');
col=[[0 0.4470 0.7410];[0.8500 0.3250 0.0980];[0.9290 0.6940 0.1250];[0.4940 0.1840 0.5560];[0.4660 0.6740 0.1880];[0.3010 0.7450 0.9330];[0.6350 0.0780 0.1840]];

Names=M_.endo_names(oo_.dr.order_var);

GDP_2021=1131.039; % in bns of constant 2015 USD

dn=datenum(2022,1+[3:3:12*(2053-2022)]',1); 
qtr=dn(3:end);

wts=[1/4,1/2,1/4];

growth_historical_GDP=1.012;
growth_historical_O=1.0077;
growth_historical_PoP=1.004; %labor force growth
growth_historical_PRD=1.008; %productivity growth
growth_forecast_GDP=[1.01175;1.00675;1.00675;1.00675;1.00675;1.01*ones(1,116)'];
growth_forecast_O=growth_forecast_GDP;
growth_forecast_PoP=1.004*ones(1,121)';
growth_forecast_PRD=1.008*ones(1,121)';

tmp=1:22;
ER_ann = table2array(data(:,26));	
EF_ann = table2array(data(:,25));				
ER_ann(isnan(ER_ann))=[];
EF_ann(isnan(EF_ann))=[];
ER = interp1(tmp,ER_ann,linspace(min(tmp),max(tmp),88))'; 
EF = interp1(tmp,EF_ann,linspace(min(tmp),max(tmp),88))'; 

ER_2021 = 25.6721205;  %million tonnes of oil equivalent
EF_2021 = 132.7363016; %million tonnes of oil equivalent

growth_historical_ER=1+mean(diff(log(ER)));
growth_historical_EF=1+mean(diff(log(EF)));
growth_forecast_ER=growth_forecast_GDP;
growth_forecast_EF=growth_forecast_GDP;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



tmp=cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="tOd")),:);
mean_unconforecast_tO=[oo_.SmoothedVariables.tOd;cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="tOd")),:)']*1000;		%simply the constant tax rate interpreted as 2022 $ per ton of CO2.
mean_forecast_tO=[oo_.SmoothedVariables.tOd;[tmp(1),conv(tmp,wts,'valid'),tmp(end)]']*1000;
lowr_forecast_tO=[oo_.SmoothedVariables.tOd;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="tOd")),:)']*1000;
uppr_forecast_tO=[oo_.SmoothedVariables.tOd;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="tOd")),:)']*1000;

mean_unconforecast_sEF=[oo_.SmoothedVariables.sEFd;cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="sEFd")),:)']*1000;		%simply the constant tax rate interpreted as 2022 $ per ton of CO2.
mean_forecast_sEF=[oo_.SmoothedVariables.sEFd;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="sEFd")),:)']*1000;

mean_unconforecast_sER=[oo_.SmoothedVariables.sERd;cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="sERd")),:)']*(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)/(ER_2021*1000000/4)*GDP_2021*1000000000; %2015 USD of 1 tonne of oil equivalent 
mean_forecast_sER=     [oo_.SmoothedVariables.sERd;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="sERd")),:)']*(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)/(ER_2021*1000000/4)*GDP_2021*1000000000;
lowr_forecast_sER=     [oo_.SmoothedVariables.sERd;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="sERd")),:)']*(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)/(ER_2021*1000000/4)*GDP_2021*1000000000;
uppr_forecast_sER=     [oo_.SmoothedVariables.sERd;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="sERd")),:)']*(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)/(ER_2021*1000000/4)*GDP_2021*1000000000;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');

plot(qtr,mean_forecast_tO(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_forecast_tO(90:end); flip(uppr_forecast_tO(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

plot(qtr,mean_forecast_sEF(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

ylim([0;max(uppr_forecast_tO(90:end))]);
set(gca, 'YTick',0:20:240)

ylabel('Constant 2015 USD per tonne of CO2');

grid on
yyaxis right
set(gca, 'YColor','k','YTick',0:300:3600)

plot(qtr,mean_forecast_sER(90:end),'LineStyle','-','LineWidth',1,'color',col(3,:));

patch([qtr; flip(qtr)], [lowr_forecast_sER(90:end); flip(uppr_forecast_sER(90:end))], col(3,:),'EdgeColor','none', 'facealpha',0.3)

ylim([0;max(uppr_forecast_tO(90:end)*15)]);

ylabel('Constant 2015 USD per tonne of oil equivalent');

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Carbon tax, fossil subsidy, and renewable subsidy');
legend("Carbon tax (left axis)","","Fossil energy subsidy (left axis)","Renewable energy subsidy (right axis)","",'Location','southeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_4a.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




mean_forecast_CGpolicy=     [oo_.SmoothedVariables.CG;[cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="CG")),:)'+cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="CGd")),:)']]*100;
lowr_forecast_CGpolicy=     [oo_.SmoothedVariables.CG;[ci_low(find(oo_.dr.order_var==find(M_.endo_names=="CG")),:)'+ci_low(find(oo_.dr.order_var==find(M_.endo_names=="CGd")),:)']]*100;
uppr_forecast_CGpolicy=     [oo_.SmoothedVariables.CG;[ci_up(find(oo_.dr.order_var==find(M_.endo_names=="CG")),:)'+ci_up(find(oo_.dr.order_var==find(M_.endo_names=="CGd")),:)']]*100;

mean_forecast_TLLd=     [oo_.SmoothedVariables.TLLd;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="TLLd")),:)']*100;
lowr_forecast_TLLd=     [oo_.SmoothedVariables.TLLd;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="TLLd")),:)']*100;
uppr_forecast_TLLd=     [oo_.SmoothedVariables.TLLd;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="TLLd")),:)']*100;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

plot(qtr,mean_forecast_CGpolicy(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_forecast_CGpolicy(90:end); flip(uppr_forecast_CGpolicy(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

ylabel('% of trend GDP');

grid on
yyaxis right
set(gca, 'YColor','k','YTick',[5:1:5+0.5*12])

plot(qtr,mean_forecast_TLLd(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

patch([qtr; flip(qtr)], [lowr_forecast_TLLd(90:end); flip(uppr_forecast_TLLd(90:end))], col(2,:),'EdgeColor','none', 'facealpha',0.3)

ylabel('% of trend GDP');

ylim([5;5+0.5*12]);

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Government consumption and low-skilled household transfers');
legend("Government consumption (left axis)","","Low-skilled household transfers (right axis)","",'Location','northeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_4b.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





mean_forecast_IGFinf=     [oo_.SmoothedVariables.IGFinf;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="IGFinf")),:)']*100;
lowr_forecast_IGFinf=     [oo_.SmoothedVariables.IGFinf;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="IGFinf")),:)']*100;
uppr_forecast_IGFinf=     [oo_.SmoothedVariables.IGFinf;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="IGFinf")),:)']*100;

mean_forecast_IGRinf=     [oo_.SmoothedVariables.IGRinf;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="IGRinf")),:)']*100;
lowr_forecast_IGRinf=     [oo_.SmoothedVariables.IGRinf;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="IGRinf")),:)']*100;
uppr_forecast_IGRinf=     [oo_.SmoothedVariables.IGRinf;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="IGRinf")),:)']*100;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');


plot(qtr,mean_forecast_IGFinf(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_forecast_IGFinf(90:end); flip(uppr_forecast_IGFinf(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

ylabel('% of trend GDP');

grid on
%yyaxis right
%set(gca, 'YColor','k')

plot(qtr,mean_forecast_IGRinf(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

patch([qtr; flip(qtr)], [lowr_forecast_IGRinf(90:end); flip(uppr_forecast_IGRinf(90:end))], col(2,:),'EdgeColor','none', 'facealpha',0.3)

%ylabel('%-deviation from baseline');

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Public investment in fossil and renewable infrastructure');
legend("Fossil infrastructure investment","","Renewable infrastructure investment","",'Location','northeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_4c.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




mean_forecast_IGFgen=     [oo_.SmoothedVariables.IGFgen;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="IGFgen")),:)']*100;
lowr_forecast_IGFgen=     [oo_.SmoothedVariables.IGFgen;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="IGFgen")),:)']*100;
uppr_forecast_IGFgen=     [oo_.SmoothedVariables.IGFgen;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="IGFgen")),:)']*100;


mean_forecast_IGFbb=     [oo_.SmoothedVariables.IGFbb;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="IGFbb")),:)']*100;
lowr_forecast_IGFbb=     [oo_.SmoothedVariables.IGFbb;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="IGFbb")),:)']*100;
uppr_forecast_IGFbb=     [oo_.SmoothedVariables.IGFbb;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="IGFbb")),:)']*100;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');


plot(qtr,mean_forecast_IGFgen(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_forecast_IGFgen(90:end); flip(uppr_forecast_IGFgen(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

ylabel('% of trend GDP');

grid on
%yyaxis right
%set(gca, 'YColor','k')

plot(qtr,mean_forecast_IGFbb(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

patch([qtr; flip(qtr)], [lowr_forecast_IGFbb(90:end); flip(uppr_forecast_IGFbb(90:end))], col(2,:),'EdgeColor','none', 'facealpha',0.3)

%ylabel('%-deviation from baseline');

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Public investment in fossil energy production and stranded asset purchases');
legend("Public investment in fossil energy production","","Bad-bank purchases of stranded assets","",'Location','northwest','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_4d.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



mean_unconforecast_GDP=[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_unconforecast_GDP=[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';ci_low_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_unconforecast_GDP=[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';ci_up_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_forecast_GDP=     [oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_forecast_GDP=     [oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_forecast_GDP=     [oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_percent_dev_baseline_GDP =  [zeros(90,1);100*(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'./cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'-1)];
lowr_percent_dev_baseline_GDP =  [zeros(90,1);ci_low_dev(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'];
uppr_percent_dev_baseline_GDP =  [zeros(90,1);ci_up_dev(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'];

mean_forecast_fiscon_GDP=     [oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';cond_forecast_fiscon(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

tmp=cond_forecast_fiscon(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:);
mean_percent_dev_fiscon_baseline_GDP =  [zeros(90,1);100*([tmp(1),conv(tmp,wts,'valid'),tmp(end)]'./cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'-1)];




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

h=plot(qtr,mean_percent_dev_baseline_GDP(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_GDP(90:end); flip(uppr_percent_dev_baseline_GDP(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,mean_percent_dev_fiscon_baseline_GDP(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

grid on
ylabel('%-deviation from baseline');
%ylim([min([lowr_percent_dev_baseline_GDP(90:end);lowr_percent_dev_fiscon_baseline_GDP]);max(uppr_percent_dev_baseline_GDP(90:end))]);

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Gross domestic product');
legend("GDP (low-carbon transition)","","GDP (fiscal consolidation)",'Location','northeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_6a.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%








mean_unconforecast_Con=[oo_.SmoothedVariables.Con.*(growth_historical_GDP.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_Con=     [oo_.SmoothedVariables.Con.*(growth_historical_GDP.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_forecast_Con=     [oo_.SmoothedVariables.Con.*(growth_historical_GDP.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_forecast_Con=     [oo_.SmoothedVariables.Con.*(growth_historical_GDP.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_percent_dev_baseline_Con =  [zeros(90,1);100*(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'./cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'-1)];
lowr_percent_dev_baseline_Con =  [zeros(90,1);ci_low_dev(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'];
uppr_percent_dev_baseline_Con =  [zeros(90,1);ci_up_dev(find(oo_.dr.order_var==find(M_.endo_names=="Con")),:)'];

mean_unconforecast_Inv=[oo_.SmoothedVariables.Inv.*(growth_historical_GDP.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_Inv=     [oo_.SmoothedVariables.Inv.*(growth_historical_GDP.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_forecast_Inv=     [oo_.SmoothedVariables.Inv.*(growth_historical_GDP.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_forecast_Inv=     [oo_.SmoothedVariables.Inv.*(growth_historical_GDP.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_percent_dev_baseline_Inv =  [zeros(90,1);100*(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'./cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'-1)];
lowr_percent_dev_baseline_Inv =  [zeros(90,1);ci_low_dev(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'];
uppr_percent_dev_baseline_Inv =  [zeros(90,1);ci_up_dev(find(oo_.dr.order_var==find(M_.endo_names=="Inv")),:)'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

h=plot(qtr,mean_percent_dev_baseline_Con(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_Con(90:end); flip(uppr_percent_dev_baseline_Con(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,mean_percent_dev_baseline_Inv(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_Inv(90:end); flip(uppr_percent_dev_baseline_Inv(90:end))], col(2,:),'EdgeColor','none', 'facealpha',0.3)

grid on
ylabel('%-deviation from baseline');
%ylim([min([lowr_percent_dev_baseline_Con(90:end);lowr_percent_dev_baseline_Inv(90:end)]);max([uppr_percent_dev_baseline_Inv(90:end);mean_percent_dev_baseline_Inv(90:end)])]);

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Consumption and investment');
legend("Consumption","","Investment","",'Location','northwest','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_6b.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





dn=datenum(2000,1+[3:3:12*(2053-2000)]',1); 
qtr=dn(2:end);



mean_unconforecast_IPF=[oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="IPF")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_IPF=     [oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="IPF")),:)'  .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_forecast_IPF=     [oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="IPF")),:)'                .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_forecast_IPF=     [oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="IPF")),:)'                 .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_unconforecast_IPR=[oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="IPR")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_IPR=     [oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="IPR")),:)'  .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_forecast_IPR=     [oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="IPR")),:)'                .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_forecast_IPR=     [oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="IPR")),:)'                 .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');

h=plot(qtr,mean_unconforecast_IPR(1:end),'LineStyle',':','LineWidth',1,'color',col(5,:));

hold on;

h=plot(qtr,mean_forecast_IPR(1:end),'LineStyle','-','LineWidth',1,'color',col(5,:));

patch([qtr; flip(qtr)], [lowr_forecast_IPR(1:end); flip(uppr_forecast_IPR(1:end))], col(5,:),'EdgeColor','none', 'facealpha',0.3)

ylabel('Billions of constant 2015 USD');
ylim([-10;190]);

grid on
yyaxis right

plot(qtr,mean_unconforecast_IPF(1:end),'LineStyle',':','LineWidth',1,'color',col(7,:));

plot(qtr,mean_forecast_IPF(1:end),'LineStyle','-','LineWidth',1,'color',col(7,:));

patch([qtr; flip(qtr)], [lowr_forecast_IPF(1:end); flip(uppr_forecast_IPF(1:end))], col(7,:),'EdgeColor','none', 'facealpha',0.3)

ylim([-10;190]/10);

set(gca, 'YColor','k')
ylabel('Billions of constant 2015 USD');

datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('Private renewable and fossil investment (annualized)');
legend("Renewable investment (baseline, left axis)","Renewable investment (policy forecast, left axis)","","Fossil investment (baseline, right axis)","Fossil investment (policy forecast, right axis)","",'Location','northwest','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 15 4]);
print(tmp,'-depsc','Figure_5a.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






mean_unconforecast_ER=[oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="ER")),:)'.*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
mean_forecast_ER=     [oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="ER")),:)'  .*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
lowr_forecast_ER=     [oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="ER")),:)'                .*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
uppr_forecast_ER=     [oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="ER")),:)'                 .*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;

mean_unconforecast_EF=[oo_.SmoothedVariables.EF.*(growth_historical_EF.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="EF")),:)'.*growth_historical_EF^89.*cumprod(growth_forecast_EF)]/(oo_.SmoothedVariables.EF(87)*growth_historical_EF^86)*EF_2021;
mean_forecast_EF=     [oo_.SmoothedVariables.EF.*(growth_historical_EF.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="EF")),:)'  .*growth_historical_EF^89.*cumprod(growth_forecast_EF)]/(oo_.SmoothedVariables.EF(87)*growth_historical_EF^86)*EF_2021;
lowr_forecast_EF=     [oo_.SmoothedVariables.EF.*(growth_historical_EF.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="EF")),:)'                .*growth_historical_EF^89.*cumprod(growth_forecast_EF)]/(oo_.SmoothedVariables.EF(87)*growth_historical_EF^86)*EF_2021;
uppr_forecast_EF=     [oo_.SmoothedVariables.EF.*(growth_historical_EF.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="EF")),:)'                 .*growth_historical_EF^89.*cumprod(growth_forecast_EF)]/(oo_.SmoothedVariables.EF(87)*growth_historical_EF^86)*EF_2021;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');

h=plot(qtr,mean_unconforecast_ER(1:end),'LineStyle',':','LineWidth',1,'color',col(5,:));

hold on;

h=plot(qtr,mean_forecast_ER(1:end),'LineStyle','-','LineWidth',1,'color',col(5,:));

patch([qtr; flip(qtr)], [lowr_forecast_ER(1:end); flip(uppr_forecast_ER(1:end))], col(5,:),'EdgeColor','none', 'facealpha',0.3)

grid on

h=plot(qtr,mean_unconforecast_EF(1:end),'LineStyle',':','LineWidth',1,'color',col(7,:));

h=plot(qtr,mean_forecast_EF(1:end),'LineStyle','-','LineWidth',1,'color',col(7,:));

ylabel("Millions of tonnes of oil equivalent");
ylim([min([lowr_forecast_ER(1:end);lowr_forecast_EF(1:end)]);max([uppr_forecast_ER(1:end);uppr_forecast_EF(1:end);mean_unconforecast_EF(1:end)])]);

patch([qtr; flip(qtr)], [lowr_forecast_EF(1:end); flip(uppr_forecast_EF(1:end))], col(7,:),'EdgeColor','none', 'facealpha',0.3)


datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('Final energy consumption (annualized)');
xlabel("Quarters");
legend("Renewable energy (baseline)","Renewable energy (policy forecast)","","Fossil energy (baseline)","Fossil energy (policy forecast)","",'Location','northwest','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 15 4]);
print(tmp,'-depsc','Figure_5b.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




dn=datenum(2022,1+[3:3:12*(2053-2022)]',1); 
qtr=dn(3:end);

mean_unconforecast_Ex=[oo_.SmoothedVariables.Ex.*(growth_historical_GDP.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_Ex=     [oo_.SmoothedVariables.Ex.*(growth_historical_GDP.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'  .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_forecast_Ex=     [oo_.SmoothedVariables.Ex.*(growth_historical_GDP.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'                .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_forecast_Ex=     [oo_.SmoothedVariables.Ex.*(growth_historical_GDP.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'                 .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_percent_dev_baseline_Ex =  [zeros(90,1);100*(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'./cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'-1)];
lowr_percent_dev_baseline_Ex =  [zeros(90,1);ci_low_dev(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'];
uppr_percent_dev_baseline_Ex =  [zeros(90,1);ci_up_dev(find(oo_.dr.order_var==find(M_.endo_names=="Ex")),:)'];

mean_unconforecast_Im=[oo_.SmoothedVariables.Im.*(growth_historical_GDP.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_Im=     [oo_.SmoothedVariables.Im.*(growth_historical_GDP.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'  .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
lowr_forecast_Im=     [oo_.SmoothedVariables.Im.*(growth_historical_GDP.^(0:89))';ci_low(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'                .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
uppr_forecast_Im=     [oo_.SmoothedVariables.Im.*(growth_historical_GDP.^(0:89))';ci_up(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'                 .*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_percent_dev_baseline_Im =  [zeros(90,1);100*(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'./cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'-1)];
lowr_percent_dev_baseline_Im =  [zeros(90,1);ci_low_dev(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'];
uppr_percent_dev_baseline_Im =  [zeros(90,1);ci_up_dev(find(oo_.dr.order_var==find(M_.endo_names=="Im")),:)'];

mean_unconforecast_Im_O=[0.87*oo_.SmoothedVariables.pO_RoW.*oo_.SmoothedVariables.O.*(growth_historical_GDP.^(0:89))';0.87*cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="pO_RoW")),:)'.*cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="O")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_Im_O=[0.87*oo_.SmoothedVariables.pO_RoW.*oo_.SmoothedVariables.O.*(growth_historical_GDP.^(0:89))';0.87*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="pO_RoW")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="O")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

mean_percent_dev_baseline_Im_O =  100*(mean_forecast_Im_O - mean_unconforecast_Im_O)./mean_unconforecast_Im_O;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

h=plot(qtr,mean_percent_dev_baseline_Ex(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;
grid on

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_Ex(90:end); flip(uppr_percent_dev_baseline_Ex(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,mean_percent_dev_baseline_Im(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_Im(90:end); flip(uppr_percent_dev_baseline_Im(90:end))], col(2,:),'EdgeColor','none', 'facealpha',0.3)

ylabel('%-deviation from baseline');
ylim([min([lowr_percent_dev_baseline_Im(90:end);lowr_percent_dev_baseline_Ex(90:end)]);max([uppr_percent_dev_baseline_Im(90:end);uppr_percent_dev_baseline_Ex(90:end);mean_percent_dev_baseline_Im(90:end)])]);

yyaxis right
set(gca, 'YColor','k')

h=plot(qtr,mean_percent_dev_baseline_Im_O(90:end),'LineStyle','-','LineWidth',1,'color',col(4,:));

%patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_Im_O(90:end); flip(uppr_percent_dev_baseline_Im_O(90:end))], col(2,:),'EdgeColor','none', 'facealpha',0.3)

ylabel('%-deviation from baseline');
ylim([min([lowr_percent_dev_baseline_Im(90:end);lowr_percent_dev_baseline_Ex(90:end)]);max([uppr_percent_dev_baseline_Im(90:end);uppr_percent_dev_baseline_Ex(90:end);mean_percent_dev_baseline_Im(90:end)])]*10);

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Exports and imports');
xlabel("Quarters");
legend("Exports (left axis)","","Imports (left axis)","","Oil imports (right axis)",'Location','northeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_6c.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%









delay = importdata('cond_forecast_policy_delay_noBG_nosERd.mat');
mean_unconforecast_pSF_delay=[oo_.SmoothedVariables.pSF;cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];
mean_forecast_pSF_delay     =[oo_.SmoothedVariables.pSF;delay(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];

mean_percent_dev_baseline_pSF_delay =  100*(mean_forecast_pSF_delay./mean_unconforecast_pSF_delay-1);

mean_unconforecast_pSF=[oo_.SmoothedVariables.pSF;cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];
mean_forecast_pSF=     [oo_.SmoothedVariables.pSF;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];
lowr_forecast_pSF=     [oo_.SmoothedVariables.pSF;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];
uppr_forecast_pSF=     [oo_.SmoothedVariables.pSF;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'.*cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];

mean_percent_dev_baseline_pSF =  [zeros(90,1);100*(cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'./cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'-1)];
lowr_percent_dev_baseline_pSF =  [zeros(90,1);ci_low_dev(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];
uppr_percent_dev_baseline_pSF =  [zeros(90,1);ci_up_dev(find(oo_.dr.order_var==find(M_.endo_names=="pSF")),:)'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

h=plot(qtr,mean_percent_dev_baseline_pSF(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_pSF(90:end); flip(uppr_percent_dev_baseline_pSF(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,mean_percent_dev_baseline_pSF_delay(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

grid on
ylabel('%-deviation from baseline');
%ylim([min([lowr_percent_dev_baseline_LH(90:end);lowr_percent_dev_baseline_LL(90:end)]);max([uppr_percent_dev_baseline_LL(90:end);mean_percent_dev_baseline_LL(90:end)])]);

datetick('x','QQ-YYYY')   
xlim([dn(3) dn(end)])  
title('Fossil equity share prices');
legend("Fossil equity share prices (orderly transition)","","Fossil equity share prices (delayed transition)",'Location','northwest','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_6e.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





delay = importdata('cond_forecast_policy_delay_noBG_nosERd.mat');
mean_forecast_KGFbb_delay=     [oo_.SmoothedVariables.KGFbb;delay(find(oo_.dr.order_var==find(M_.endo_names=="KGFbb")),:)']*100/4;

mean_unconforecast_KGFbb=[oo_.SmoothedVariables.KGFbb;cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="KGFbb")),:)']*100/4;
mean_forecast_KGFbb=     [oo_.SmoothedVariables.KGFbb;cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="KGFbb")),:)']*100/4;
lowr_forecast_KGFbb=     [oo_.SmoothedVariables.KGFbb;ci_low(find(oo_.dr.order_var==find(M_.endo_names=="KGFbb")),:)']*100/4;
uppr_forecast_KGFbb=     [oo_.SmoothedVariables.KGFbb;ci_up(find(oo_.dr.order_var==find(M_.endo_names=="KGFbb")),:)']*100/4;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

h=plot(qtr,mean_forecast_KGFbb(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_forecast_KGFbb(90:end); flip(uppr_forecast_KGFbb(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,mean_forecast_KGFbb_delay(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

grid on;

%ylim([min(mean_forecast_KGFbb_delay(90:end));max(mean_forecast_KGFbb_delay(90:end))]);

%set(gca, 'YColor','k')
ylabel('% of annualized trend GDP');

datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('Stranded fossil capital stock at replacement cost');
xlabel("Quarters");
legend("Stranded capital stock (orderly transition)","","Stranded capital stock (delayed transition)",'Location','northwest','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_6f.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





load lambda_unconditional_H.mat
load lambda_unconditional_H_wealth.mat
load lambda_unconditional_L.mat

lambda_unconditional_H       =[lambda_unconditional_H(1),conv(lambda_unconditional_H,wts,'valid'),lambda_unconditional_H(end)];
lambda_unconditional_H_wealth=[lambda_unconditional_H_wealth(1),conv(lambda_unconditional_H_wealth,wts,'valid'),lambda_unconditional_H_wealth(end)];
lambda_unconditional_L       =[lambda_unconditional_L(1),conv(lambda_unconditional_L,wts,'valid'),lambda_unconditional_L(end)];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

h=plot(qtr,[0;100*-lambda_unconditional_H_wealth'],'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;
grid on

patch([qtr; flip(qtr)], [[0;100*-lambda_unconditional_H']; flip([0;100*-lambda_unconditional_H'])], [0 0 0],'EdgeColor','none', 'facealpha',0.3)

ylabel('% of baseline consumption');
ylim([-20;50]);

yyaxis right
set(gca, 'YColor','k','YTick',[-20/10:1:50/10])

h=plot(qtr,[0;100*-lambda_unconditional_H'],'LineStyle','-','LineWidth',1,'color',col(2,:));

h=plot(qtr,[0;100*-lambda_unconditional_L'],'LineStyle','-','LineWidth',1,'color',col(3,:));

ylabel('% of baseline consumption');
ylim([-20;50]/10);

datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('High-skilled and low-skilled welfare gains');
xlabel("Quarters");
legend("High-skilled households (with wealth, left axis)","","High-skilled households (without wealth, right axis)",  "Low-skilled households (right axis)" ,'Location','northeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_6d.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






growth_historical_O=1.0077;
growth_forecast_O=growth_forecast_GDP;

mean_unconforecast_O=[oo_.SmoothedVariables.O.*(growth_historical_O.^(0:89))';cond_forecast_nopolicy(find(oo_.dr.order_var==find(M_.endo_names=="O")),:)'.*growth_historical_O^89.*cumprod(growth_forecast_O)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86) *GDP_2021*1000000000/1000/1000000; %first translate kg of emissions per GDP into total kg of emissions. then translate into tonnes. then translate into millions of tonnes.
mean_forecast_O     =[oo_.SmoothedVariables.O.*(growth_historical_O.^(0:89))';cond_forecast_policy(find(oo_.dr.order_var==find(M_.endo_names=="O")),:)'.*growth_historical_O^89.*cumprod(growth_forecast_O)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86) *GDP_2021*1000000000/1000/1000000;

GamS = importdata('cond_forecast_policy_GamS.mat');
mean_forecast_GDP_GamS =[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';GamS(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_O_GamS   =[oo_.SmoothedVariables.O.*(growth_historical_O.^(0:89))';GamS(find(oo_.dr.order_var==find(M_.endo_names=="O")),:)'.*growth_historical_O^89.*cumprod(growth_forecast_O)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86) *GDP_2021*1000000000/1000/1000000;
mean_forecast_ER_GamS  =[oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';GamS(find(oo_.dr.order_var==find(M_.endo_names=="ER")),:)'.*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
mean_forecast_IPR_GamS =[oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';GamS(find(oo_.dr.order_var==find(M_.endo_names=="IPR")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_IPF_GamS =[oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';GamS(find(oo_.dr.order_var==find(M_.endo_names=="IPF")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

lamER = importdata('cond_forecast_policy_lamER.mat');
mean_forecast_GDP_lamER=[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';lamER(find(oo_.dr.order_var==find(M_.endo_names=="GDP")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_O_lamER   =[oo_.SmoothedVariables.O.*(growth_historical_O.^(0:89))';lamER(find(oo_.dr.order_var==find(M_.endo_names=="O")),:)'.*growth_historical_O^89.*cumprod(growth_forecast_O)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86) *GDP_2021*1000000000/1000/1000000;
mean_forecast_ER_lamER  =[oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';lamER(find(oo_.dr.order_var==find(M_.endo_names=="ER")),:)'.*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
mean_forecast_IPR_lamER =[oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';lamER(find(oo_.dr.order_var==find(M_.endo_names=="IPR")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_IPF_lamER =[oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';lamER(find(oo_.dr.order_var==find(M_.endo_names=="IPF")),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

surp = importdata('simul_surprise.mat');
mean_forecast_GDP_surp =[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';surp(find(M_.endo_names=="GDP"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_O_surp   =[oo_.SmoothedVariables.O.*(growth_historical_O.^(0:89))';surp(find(M_.endo_names=="O"),:)'.*growth_historical_O^89.*cumprod(growth_forecast_O)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86) *GDP_2021*1000000000/1000/1000000;
mean_forecast_ER_surp  =[oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';surp(find(M_.endo_names=="ER"),:)'.*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
mean_forecast_IPR_surp =[oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';surp(find(M_.endo_names=="IPR"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_IPF_surp =[oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';surp(find(M_.endo_names=="IPF"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

temp = importdata('simul_reversal.mat');
mean_forecast_GDP_temp =[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';temp(find(M_.endo_names=="GDP"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_O_temp   =[oo_.SmoothedVariables.O.*(growth_historical_O.^(0:89))';temp(find(M_.endo_names=="O"),:)'.*growth_historical_O^89.*cumprod(growth_forecast_O)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86) *GDP_2021*1000000000/1000/1000000;
mean_forecast_ER_temp  =[oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';temp(find(M_.endo_names=="ER"),:)'.*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
mean_forecast_IPR_temp =[oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';temp(find(M_.endo_names=="IPR"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_IPF_temp =[oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';temp(find(M_.endo_names=="IPF"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

perf = importdata('simul_perfect_foresight.mat');
mean_forecast_GDP_perf =[oo_.SmoothedVariables.GDP.*(growth_historical_GDP.^(0:89))';perf(find(M_.endo_names=="GDP"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_O_perf   =[oo_.SmoothedVariables.O.*(growth_historical_O.^(0:89))';perf(find(M_.endo_names=="O"),:)'.*growth_historical_O^89.*cumprod(growth_forecast_O)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86) *GDP_2021*1000000000/1000/1000000;
mean_forecast_ER_perf  =[oo_.SmoothedVariables.ER.*(growth_historical_ER.^(0:89))';perf(find(M_.endo_names=="ER"),:)'.*growth_historical_ER^89.*cumprod(growth_forecast_ER)]/(oo_.SmoothedVariables.ER(87)*growth_historical_ER^86)*ER_2021;
mean_forecast_IPR_perf =[oo_.SmoothedVariables.IPR.*(growth_historical_GDP.^(0:89))';perf(find(M_.endo_names=="IPR"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;
mean_forecast_IPF_perf =[oo_.SmoothedVariables.IPF.*(growth_historical_GDP.^(0:89))';perf(find(M_.endo_names=="IPF"),:)'.*growth_historical_GDP^89.*cumprod(growth_forecast_GDP)]/(oo_.SmoothedVariables.GDP(87)*growth_historical_GDP^86)*GDP_2021;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=figure('visible','off');

dev_baseline_GDP_GamS=100*(mean_forecast_GDP_GamS-mean_unconforecast_GDP)./mean_unconforecast_GDP;
dev_baseline_GDP_lamER =100*(mean_forecast_GDP_lamER-mean_unconforecast_GDP)./mean_unconforecast_GDP;
dev_surprise_GDP_perf=100*(mean_forecast_GDP_perf-mean_forecast_GDP_surp)./mean_forecast_GDP_surp; 
dev_baseline_GDP_perf=mean_percent_dev_baseline_GDP+dev_surprise_GDP_perf;
dev_surprise_GDP_temp=100*(mean_forecast_GDP_temp-mean_forecast_GDP_surp)./mean_forecast_GDP_surp; 
dev_baseline_GDP_temp=mean_percent_dev_baseline_GDP+dev_surprise_GDP_temp;


h=plot(qtr,mean_percent_dev_baseline_GDP(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_GDP(90:end); flip(uppr_percent_dev_baseline_GDP(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,dev_baseline_GDP_perf(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

h=plot(qtr,dev_baseline_GDP_temp(90:end),'LineStyle','-','LineWidth',1,'color',col(3,:));

h=plot(qtr,dev_baseline_GDP_GamS(90:end),'LineStyle','-','LineWidth',1,'color',col(4,:));

h=plot(qtr,dev_baseline_GDP_lamER(90:end),'LineStyle','-','LineWidth',1,'color',col(5,:));

ylim([-3 3])  
set(gca, 'YTick',-3:1:3)
ylabel('%-deviation from baseline');

grid on

datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('Gross domestic product');
xlabel("Quarters");
legend("Benchmark policy forecast","","Credible policy commitment","Expected policy reversal","Lower risk premia ","Easier access to green bank lending",'Location','southwest','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_7a.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mean_percent_dev_baseline_O =  100*(mean_forecast_O - mean_unconforecast_O)./mean_unconforecast_O;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');

dev_baseline_O_GamS=100*(mean_forecast_O_GamS-mean_unconforecast_O)./mean_unconforecast_O;
dev_baseline_O_lamER =100*(mean_forecast_O_lamER-mean_unconforecast_O)./mean_unconforecast_O;
dev_surprise_O_perf=100*(mean_forecast_O_perf-mean_forecast_O_surp)./mean_forecast_O_surp; 
dev_baseline_O_perf=mean_percent_dev_baseline_O+dev_surprise_O_perf;
dev_surprise_O_temp=100*(mean_forecast_O_temp-mean_forecast_O_surp)./mean_forecast_O_surp; 
dev_baseline_O_temp=mean_percent_dev_baseline_O+dev_surprise_O_temp;


h=plot(qtr,mean_percent_dev_baseline_O(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [mean_percent_dev_baseline_O(90:end); flip(mean_percent_dev_baseline_O(90:end))], [0 0 0],'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,dev_baseline_O_perf(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

h=plot(qtr,dev_baseline_O_temp(90:end),'LineStyle','-','LineWidth',1,'color',col(3,:));

h=plot(qtr,dev_baseline_O_GamS(90:end),'LineStyle','-','LineWidth',1,'color',col(4,:));

h=plot(qtr,dev_baseline_O_lamER(90:end),'LineStyle','-','LineWidth',1,'color',col(5,:));

ylabel('%-deviation from baseline');
ylim([-100;0]);

grid on

datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('Emissions');
xlabel("Quarters");
legend("Benchmark policy forecast","","Credible policy commitment","Expected policy reversal","Lower risk premia ","Easier access to green bank lending",'Location','northeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_7b.eps');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mean_percent_dev_baseline_ER =  100*(mean_forecast_ER - mean_unconforecast_ER)./mean_unconforecast_ER;
lowr_percent_dev_baseline_ER =  100*(lowr_forecast_ER - mean_unconforecast_ER)./mean_unconforecast_ER;
uppr_percent_dev_baseline_ER =  100*(uppr_forecast_ER - mean_unconforecast_ER)./mean_unconforecast_ER;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');

dev_baseline_ER_GamS=100*(mean_forecast_ER_GamS-mean_unconforecast_ER)./mean_unconforecast_ER;
dev_baseline_ER_lamER =100*(mean_forecast_ER_lamER-mean_unconforecast_ER)./mean_unconforecast_ER;
dev_surprise_ER_perf=100*(mean_forecast_ER_perf-mean_forecast_ER_surp)./mean_forecast_ER_surp; 
dev_baseline_ER_perf=mean_percent_dev_baseline_ER+dev_surprise_ER_perf;
dev_surprise_ER_temp=100*(mean_forecast_ER_temp-mean_forecast_ER_surp)./mean_forecast_ER_surp; 
dev_baseline_ER_temp=mean_percent_dev_baseline_ER+dev_surprise_ER_temp;

h=plot(qtr,mean_percent_dev_baseline_ER(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_ER(90:end); flip(uppr_percent_dev_baseline_ER(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,dev_baseline_ER_perf(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

h=plot(qtr,dev_baseline_ER_temp(90:end),'LineStyle','-','LineWidth',1,'color',col(3,:));

h=plot(qtr,dev_baseline_ER_GamS(90:end),'LineStyle','-','LineWidth',1,'color',col(4,:));

h=plot(qtr,dev_baseline_ER_lamER(90:end),'LineStyle','-','LineWidth',1,'color',col(5,:));

ylabel('%-deviation from baseline');

grid on

datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('Final renewable energy consumption');
xlabel("Quarters");
legend("Benchmark policy forecast","","Credible policy commitment","Expected policy reversal","Lower risk premia ","Easier access to green bank lending",'Location','southeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_7c.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mean_percent_dev_baseline_IPR  =  100*(mean_forecast_IPR  - mean_unconforecast_IPR )./mean_unconforecast_IPR ;
lowr_percent_dev_baseline_IPR  =  100*(lowr_forecast_IPR  - mean_unconforecast_IPR )./mean_unconforecast_IPR ;
uppr_percent_dev_baseline_IPR  =  100*(uppr_forecast_IPR  - mean_unconforecast_IPR )./mean_unconforecast_IPR ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tmp=figure('visible','off');

dev_baseline_IPR_GamS=100*(mean_forecast_IPR_GamS-mean_unconforecast_IPR)./mean_unconforecast_IPR;
dev_baseline_IPR_lamER =100*(mean_forecast_IPR_lamER-mean_unconforecast_IPR)./mean_unconforecast_IPR;
dev_surprise_IPR_perf=100*(mean_forecast_IPR_perf-mean_forecast_IPR_surp)./mean_forecast_IPR_surp; 
dev_baseline_IPR_perf=mean_percent_dev_baseline_IPR+dev_surprise_IPR_perf;
dev_surprise_IPR_temp=100*(mean_forecast_IPR_temp-mean_forecast_IPR_surp)./mean_forecast_IPR_surp; 
dev_baseline_IPR_temp=mean_percent_dev_baseline_IPR+dev_surprise_IPR_temp;

h=plot(qtr,mean_percent_dev_baseline_IPR(90:end),'LineStyle','-','LineWidth',1,'color',col(1,:));

hold on;

patch([qtr; flip(qtr)], [lowr_percent_dev_baseline_IPR(90:end); flip(uppr_percent_dev_baseline_IPR(90:end))], col(1,:),'EdgeColor','none', 'facealpha',0.3)

h=plot(qtr,dev_baseline_IPR_perf(90:end),'LineStyle','-','LineWidth',1,'color',col(2,:));

h=plot(qtr,dev_baseline_IPR_temp(90:end),'LineStyle','-','LineWidth',1,'color',col(3,:));

h=plot(qtr,dev_baseline_IPR_GamS(90:end),'LineStyle','-','LineWidth',1,'color',col(4,:));

h=plot(qtr,dev_baseline_IPR_lamER(90:end),'LineStyle','-','LineWidth',1,'color',col(5,:));

ylabel('%-deviation from baseline');

grid on

datetick('x','QQ-YYYY')   
xlim([dn(1) dn(end)])  
title('Private renewable investment');
xlabel("Quarters");
legend("Benchmark policy forecast","","Credible policy commitment","Expected policy reversal","Lower risk premia ","Easier access to green bank lending",'Location','southeast','Box','off');

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 4]);
print(tmp,'-depsc','Figure_7d.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%










y=["kap";"vrh";"etaH";"sigER";"sigEF";"sigSZ";"sigSF";"sigL";"sigW";"sigW_RoW";"sigE";"sigY";"tauW";"tauP";"tauI";"tauE";"tauO";"tauZe";"xiELe";"phiWE";"phiWP";"phiCY";"phiRP";"phiRY"];

for ii   = 1:length(y(:,1))

prior(ii,:,:)  = eval(strcat('oo_.prior_density.parameters.',y(ii,:)));
posterior(ii,:,:)  = eval(strcat('oo_.posterior_density.parameters.',y(ii,:)));
mode(ii,:)  = eval(strcat('oo_.posterior_mode.parameters.',y(ii,:)));

end

names=["Consumption habit persistence","Inverse elast. of intertemp. subst.","Inverse Frisch elast. of labor supply","E.o.s between capital and labor for renew.", "E.o.s between capital and labor for fossil","E.o.s between value-added and energy","E.o.s between value added and carbon","E.o.s between high and low-skilled labor", "Import price elasticity", "Export price elasticity", "E.o.s between renewable and fossil energy","E.o.s between core goods and energy","High-skilled wage adjustment cost","Core good price adjustment cost","Investment adjustment cost","Renewable input adjustment cost","Carbon input adjustment cost","Export adjustment cost","Calvo empl. param.","Empl. elas. of low-skilled wage infl.","Price infl. elas. of low-skilled wage infl.","Output gap elas. of gov. cons.","Core infl. elas. of policy rate","Output gap elas. of policy rate"];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('visible','off');
tmp=figure('visible','off');
axes('FontSize',6);
for ii=1:length(y)
subplot(8,3,ii);

hold on;

hh=plot(prior(ii,:,1),prior(ii,:,2),'-k','LineWidth',2);
set(hh,'color',[0.7 0.7 0.7]);
hold on;
plot(posterior(ii,:,1),posterior(ii,:,2),'-k','LineWidth',2);

h=xline(mode(ii,:));
set(h(1),'LineStyle','--','LineWidth',2,'color',[0 0.6 0]);

ylim([0;max(max(prior(ii,:,2),max(posterior(ii,:,2))))]);

title(names(ii), 'fontsize', 9,'FontWeight','bold');
end

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 15 16]);
print(tmp,'-depsc','Figure_B1.eps');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





clear
load('time_varying_elasticity.mat')

zeros=find(tmp(:,1)==0);
tmp(zeros,:)=[];
ci_up=[];
ci_low=[];

for j = 1:121
    ci_up(j)=prctile(tmp(:,j),95);
    ci_mean(j)=mean(tmp(:,j));
    ci_low(j)=prctile(tmp(:,j),5);
end

qtr=(0:20)';

tmp=figure('visible','off');

hold on;

h=plot(qtr,ci_mean(1:21));
set(h(1),'LineStyle','-','LineWidth',1,'color',[0 0.4470 0.7410]/2);

patch([qtr; flip(qtr)], [ci_up(1:21)'; flip(ci_low(1:21)')], [0 0.4470 0.7410],'EdgeColor','none', 'facealpha',0.3)

grid on

title('Time varying elasticity of substitution between renewable and fossil energy');
xlabel("Quarters");

set(tmp, 'PaperUnits', 'inches', 'PaperPosition', [0 0 8 2]);
print(tmp,'-depsc','Figure_2.eps');



