var pE GamE dGamER tEFd ER EF lEREF lMTRS_RF;

varexo tEFd_shock;

parameters sigE alpE tauE pER pEF E;

pd = load('./estimation/metropolis/estimation_posterior_draws1.mat');
D = cell2mat(pd.pdraws);       
post_sigE=D(:,43);
post_tauE=D(:,50);

for iter = 1:500
try 

set_param_value('sigE', post_sigE(iter))
set_param_value('tauE', post_tauE(iter))

alpE=0.002;
pER=0.050171825118159;
pEF=0.070824669332411;
E=0.710753184079323;

model;
((pER)/pE)^sigE = E*alpE*1/(GamE*ER)*(dGamER*ER+GamE)^sigE;
EF = (1-alpE)*((pEF+tEFd)/pE)^(-sigE)*E;
GamE = 1-tauE/2*(ER/ER(-1)-1)^2;
dGamER =  -tauE*(ER/ER(-1)-1)*1/ER(-1);
pE*E = pER*ER + (pEF+tEFd)*EF;

tEFd = 0.99999*tEFd(-1) + tEFd_shock;

%MPER = (E*alpE*1/(GamE*ER)*(dGamER*ER+GamE)^sigE)^(1/sigE);
%MPEF = (E*(alpE^(1/sigE)*(GamE*ER)^(-1/sigE)*dGamEF*ER+(1-alpE)^(1/sigE)*EF^(-1/sigE))^sigE)^(1/sigE);

lMTRS_RF = 100*log((E*((1-alpE)^(1/sigE)*EF^(-1/sigE))^sigE)^(1/sigE)/(E*alpE*1/(GamE*ER)*(dGamER*ER+GamE)^sigE)^(1/sigE));
lEREF = 100*log(ER/EF);

end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

initval;
ER=0.125226372358020;
EF=0.633640763204369;
GamE=1;
dGamER=0;
tEFd=0;
pE = (pER*ER + (pEF+tEFd)*EF)/E;
lEREF=100*log(ER/EF);
lMTRS_RF = 100*log(( (alpE*1/ER) / ((1-alpE)*1/EF)  )^(1/sigE));

end;

steady;
check;

shocks;
var tEFd_shock; stderr 0.00071;
end;

stoch_simul(order=1,irf=121,nograph,noprint);

tmp(iter,:)=oo_.irfs.lEREF_tEFd_shock;

catch
end
end

save('time_varying_elasticity.mat','tmp') 






